#-------------------------------------------------
#The file is for the Calc24P as a calculation
#and random, and provides concludes or clues.
#It is written by Chao Xiong, July, 2006
#The version is 1.05
#-------------------------------------------------



from __future__ import division
import random



#--------------------------------------------------------
# get foun random integer from 1 to 9
#--------------------------------------------------------
def getRandInt():
    a = random.randint
    return [a(1, 9), a(1, 9), a(1, 9), a(1, 9)]



#--------------------------------------------------------
# list all the sort according to the four numbers, it is
# copied from AllStartFromGame at http://python.cn
#--------------------------------------------------------
def permute(seq):
    l = len(seq)
    if l == 1:
        return [seq]
    else:
        res=[]
        for i in range(len(seq)):
            rest = seq[:i] + seq[i+1:]
            for x in permute(rest):
                res.append(seq[i:i+1] + x)
        return res



#--------------------------------------------------------
# Calculate the 24p for the inputting four numbers
#--------------------------------------------------------
def calc(data):
    """The function calculate the list 'data' which contains 4 integers
    to 24 with basic math operators. These operators include '+','-','*',
    '/' and parentheses. And it will return the equations which can produce
    24 according to 'data' and operators respectively. Of course, due to the
    poor algorithm, the function returns some same equations with different
    styles."""
    listofall = permute(tuple(data))
    newlist = list(set(listofall))
    equation = []
    opsc = ['+','-','*','/']


#--------------------------------------------------------
# consider the five different structures of combinations
#--------------------------------------------------------
    for a in newlist:
        for i in range(4):
            for j in range(4):
                for k in range(4):
                    express = []
                    value = (a[0],opsc[i],a[1],opsc[j],a[2],opsc[k],a[3])
                    express.append("((%d %s %d) %s %d) %s %d" % value)
                    express.append("(%d %s (%d %s %d)) %s %d" % value)
                    express.append("%d %s ((%d %s %d) %s %d)" % value)
                    express.append("%d %s (%d %s (%d %s %d))" % value)
                    express.append("(%d %s %d) %s (%d %s %d)" % value)
                    for s in express:
                        try:
                            x = eval(s)
                        except:
                            continue
                        if x < 24.00001 and x > 23.99999:
                            equation.append(s)                        

    return equation
    
##    equation = list(set(equation))
##    for e in equation:
##        print e
    
##    print "there are %d" % len(equation), "items at all"
##    print "all the time of calculation is %s s" % cacltime


#--------------------------------------------------------
# Check the equation with the random integers
#--------------------------------------------------------
def checkInt(problem, equation):
    """check whether all the integers in equation are exactly
    equal to those in rand_int"""
    
    temp1 = [allint for allint in equation if allint.isdigit()]
    temp1.sort()
    temp2 = problem.split()
    temp2.sort()
    
    return temp1 == temp2


#--------------------------------------------------------
# Give a conclude after the equation is submitted
#--------------------------------------------------------
def conclude(result, flag_check = True):
    temp = []
    if result == -9999:
        temp.append('Are you Crazy!!??')
    elif (not flag_check) and result == 24:
        temp.append('Please Don\'t Cheat...')
    elif result > 24.000001 or result < 23.999999:
        temp.append('Sorry, You are wrong...')
    elif result < 24.000001 and result > 23.99999:
        temp.append('Congratulations! You are Right!!!')
    else:
        temp.append('It is impossible...Am I crazy?')
    return temp
    

#--------------------------------------------------------
# Give the clues...
#--------------------------------------------------------
def clue(key = None):
    if not key:
        clues = ['Press Enter to submit your answer.',
                 'You can input the equation with numbers and operators',
                 'The operators include: + - * / ( )',
                 'The numbers include: 1 2 3 4 5 6 7 8 9',
                 'Press Esc to Change a group of numbers.']
        theclue = clues[random.randint(0, 4)]
    else:
        theclue = key[random.randint(0, len(key)-1)]
    return theclue
        
       
